
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Purchase_ordersDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const purchase_orders = await db.purchase_orders.create(
            {
                id: data.id || undefined,
        
        po_number: data.po_number
        ||
        null
            ,
            
        total_amount_usd: data.total_amount_usd
        ||
        null
            ,
            
        currency: data.currency
        ||
        null
            ,
            
        total_amount_original: data.total_amount_original
        ||
        null
            ,
            
        issued_at: data.issued_at
        ||
        null
            ,
            
        expected_delivery_at: data.expected_delivery_at
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await purchase_orders.setTenant( data.tenant || null, {
            transaction,
        });
        
        await purchase_orders.setRequisition( data.requisition || null, {
            transaction,
        });
        
        await purchase_orders.setSupplier( data.supplier || null, {
            transaction,
        });
        
        await purchase_orders.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.purchase_orders.getTableName(),
                belongsToColumn: 'po_documents',
                belongsToId: purchase_orders.id,
            },
            data.po_documents,
            options,
        );
        

        return purchase_orders;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const purchase_ordersData = data.map((item, index) => ({
                id: item.id || undefined,
                
                po_number: item.po_number
            ||
            null
            ,
            
                total_amount_usd: item.total_amount_usd
            ||
            null
            ,
            
                currency: item.currency
            ||
            null
            ,
            
                total_amount_original: item.total_amount_original
            ||
            null
            ,
            
                issued_at: item.issued_at
            ||
            null
            ,
            
                expected_delivery_at: item.expected_delivery_at
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const purchase_orders = await db.purchase_orders.bulkCreate(purchase_ordersData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < purchase_orders.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.purchase_orders.getTableName(),
                    belongsToColumn: 'po_documents',
                    belongsToId: purchase_orders[i].id,
                },
                data[i].po_documents,
                options,
            );
        }
        

        return purchase_orders;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const purchase_orders = await db.purchase_orders.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.po_number !== undefined) updatePayload.po_number = data.po_number;
        
        
        if (data.total_amount_usd !== undefined) updatePayload.total_amount_usd = data.total_amount_usd;
        
        
        if (data.currency !== undefined) updatePayload.currency = data.currency;
        
        
        if (data.total_amount_original !== undefined) updatePayload.total_amount_original = data.total_amount_original;
        
        
        if (data.issued_at !== undefined) updatePayload.issued_at = data.issued_at;
        
        
        if (data.expected_delivery_at !== undefined) updatePayload.expected_delivery_at = data.expected_delivery_at;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        updatePayload.updatedById = currentUser.id;

        await purchase_orders.update(updatePayload, {transaction});

        
        
        if (data.tenant !== undefined) {
            await purchase_orders.setTenant(
              
              data.tenant,
              
              { transaction }
            );
        }
        
        if (data.requisition !== undefined) {
            await purchase_orders.setRequisition(
              
              data.requisition,
              
              { transaction }
            );
        }
        
        if (data.supplier !== undefined) {
            await purchase_orders.setSupplier(
              
              data.supplier,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await purchase_orders.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.purchase_orders.getTableName(),
                belongsToColumn: 'po_documents',
                belongsToId: purchase_orders.id,
            },
            data.po_documents,
            options,
        );
        

        return purchase_orders;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const purchase_orders = await db.purchase_orders.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of purchase_orders) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of purchase_orders) {
                await record.destroy({transaction});
            }
        });


        return purchase_orders;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const purchase_orders = await db.purchase_orders.findByPk(id, options);

        await purchase_orders.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await purchase_orders.destroy({
            transaction
        });

        return purchase_orders;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const purchase_orders = await db.purchase_orders.findOne(
            { where },
            { transaction },
        );

        if (!purchase_orders) {
            return purchase_orders;
        }

        const output = purchase_orders.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.po_lines_purchase_order = await purchase_orders.getPo_lines_purchase_order({
            transaction
        });
        
        
        output.goods_receipt_notes_purchase_order = await purchase_orders.getGoods_receipt_notes_purchase_order({
            transaction
        });
        
        
        
        output.service_acceptance_notes_purchase_order = await purchase_orders.getService_acceptance_notes_purchase_order({
            transaction
        });
        
        
        output.discrepancy_cases_purchase_order = await purchase_orders.getDiscrepancy_cases_purchase_order({
            transaction
        });
        
        
        
        
        
        
        
        
        
        output.tenant = await purchase_orders.getTenant({
            transaction
        });
        
        
        output.requisition = await purchase_orders.getRequisition({
            transaction
        });
        
        
        output.supplier = await purchase_orders.getSupplier({
            transaction
        });
        
        
        output.po_documents = await purchase_orders.getPo_documents({
            transaction
        });
        
        
        output.organizations = await purchase_orders.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.tenants,
        as: 'tenant',
        
        where: filter.tenant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.tenant.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.tenant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.requisitions,
        as: 'requisition',
        
        where: filter.requisition ? {
          [Op.or]: [
            { id: { [Op.in]: filter.requisition.split('|').map(term => Utils.uuid(term)) } },
            {
              req_number: {
                [Op.or]: filter.requisition.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.suppliers,
        as: 'supplier',
        
        where: filter.supplier ? {
          [Op.or]: [
            { id: { [Op.in]: filter.supplier.split('|').map(term => Utils.uuid(term)) } },
            {
              legal_name: {
                [Op.or]: filter.supplier.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'po_documents',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.po_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'purchase_orders',
                        'po_number',
                        filter.po_number,
                    ),
                };
            }
            

            
            

            
            if (filter.total_amount_usdRange) {
                const [start, end] = filter.total_amount_usdRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    total_amount_usd: {
                    ...where.total_amount_usd,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    total_amount_usd: {
                    ...where.total_amount_usd,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.total_amount_originalRange) {
                const [start, end] = filter.total_amount_originalRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    total_amount_original: {
                    ...where.total_amount_original,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    total_amount_original: {
                    ...where.total_amount_original,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.issued_atRange) {
                const [start, end] = filter.issued_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    issued_at: {
                    ...where.issued_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    issued_at: {
                    ...where.issued_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.expected_delivery_atRange) {
                const [start, end] = filter.expected_delivery_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    expected_delivery_at: {
                    ...where.expected_delivery_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    expected_delivery_at: {
                    ...where.expected_delivery_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.currency) {
                where = {
                    ...where,
                currency: filter.currency,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.purchase_orders.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'purchase_orders',
                        'po_number',
                        query,
                    ),
                ],
            };
        }

        const records = await db.purchase_orders.findAll({
            attributes: [ 'id', 'po_number' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['po_number', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.po_number,
        }));
    }

    
};

